package com.ruoyi.system.service.impl;

import cn.hutool.core.util.IdUtil;
import com.ruoyi.common.core.domain.entity.MusicCollect;
import com.ruoyi.common.core.domain.entity.UserCollect;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import com.ruoyi.system.mapper.MusicCollectMapper;
import com.ruoyi.system.mapper.UserCollectMapper;
import com.ruoyi.system.service.IUserCollectService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;

/**
 * 用户收藏音乐Service业务层处理
 * 
 * @author ruoyi
 * @date 2025-07-15
 */
@Service
public class UserCollectServiceImpl implements IUserCollectService 
{
    @Autowired
    private UserCollectMapper userCollectMapper;
    @Autowired
    private MusicCollectMapper musicCollectMapper;

    /**
     * 查询用户收藏音乐
     * 
     * @param id 用户收藏音乐主键
     * @return 用户收藏音乐
     */
    @Override
    public UserCollect selectUserCollectById(Long id)
    {
        return userCollectMapper.selectUserCollectById(id);
    }

    /**
     * 查询用户收藏音乐列表
     * 
     * @param userCollect 用户收藏音乐
     * @return 用户收藏音乐
     */
    @Override
    public List<UserCollect> selectUserCollectList(UserCollect userCollect)
    {
        return userCollectMapper.selectUserCollectList(userCollect);
    }

    /**
     * 新增用户收藏音乐
     * 
     * @param userCollect 用户收藏音乐
     * @return 结果
     */
    @Override
    public int insertUserCollect(UserCollect userCollect)
    {
        Long userId = SecurityUtils.getUserId();
        userCollect.setCollectId(IdUtil.getSnowflakeNextId());
        userCollect.setUserId(userId);
        userCollect.setCreateTime(DateUtils.getNowDate());
        return userCollectMapper.insertUserCollect(userCollect);
    }

    /**
     * 修改用户收藏音乐
     * 
     * @param userCollect 用户收藏音乐
     * @return 结果
     */
    @Override
    public int updateUserCollect(UserCollect userCollect)
    {
        userCollect.setUpdateTime(DateUtils.getNowDate());
        return userCollectMapper.updateUserCollect(userCollect);
    }

    /**
     * 批量删除用户收藏音乐
     * 
     * @param ids 需要删除的用户收藏音乐主键
     * @return 结果
     */
    @Override
    public int deleteUserCollectByIds(Long[] ids)
    {
        return userCollectMapper.deleteUserCollectByIds(ids);
    }

    /**
     * 删除用户收藏音乐信息
     * 
     * @param id 用户收藏音乐主键
     * @return 结果
     */
    @Override
    public int deleteUserCollectById(Long id)
    {
        return userCollectMapper.deleteUserCollectById(id);
    }

    @Override
    public int cancelBindMusic(MusicCollect musicCollect) {
        return musicCollectMapper.delBindMusic(musicCollect);
    }
}
